'###############################
' dump base with mysqldump.exe
' by Colee
' 24.02.2016
' v 1.1
' engineerbox.ru
'###############################
' scripts page
' http://engineerbox.ru/page/mysql_exbase
'###############################
' backup path 
PATH_2_BACKUP = "c:\tmp\"
' mysqldump can run without path (true/false)
canRunGlobal = false
' path to mysql.exe
' default c:\Program Files\MySQL\MySQL Server 5.6\bin\
MYSQL_BIN_PATH = "c:\Program Files (x86)\MySQL\MySQL Server 5.6\bin"
' database info
base_db = "test"
base_db_name = "root"
base_db_pass = "root"

' set backup extension name
backupExtensionName = "sqldump"
' set visible cmd window (1 - Show, 0 - Hide)
cmdWindowVisible = 1
' set extra options for mysqldump.exe
' http://dev.mysql.com/doc/refman/5.7/en/mysqldump.html
extradump_option = "-Q -c --routines --triggers"
'###############################

set fso = createobject("Scripting.FileSystemObject")
mysqldump_file = "mysqldump.exe"
if not canRunGlobal then
	if not fso.folderexists(MYSQL_BIN_PATH) then errormsg "     c mysql.exe" & vbcrlf & "  MYSQL_BIN_PATH" & vbcrlf & MYSQL_BIN_PATH
	mysqldump_file = fso.BuildPath(MYSQL_BIN_PATH,"mysqldump.exe")
	if not fso.fileexists(mysqldump_file) then errormsg "   mysqldump.exe" & vbcrlf & "(   mysql.exe)"& vbcrlf &mysqldump_file & vbcrlf & "  MYSQL_BIN_PATH"
end if
if not fso.folderexists(PATH_2_BACKUP) then
	on error resume next
	fso.CreateFolder PATH_2_BACKUP
	if not fso.folderexists(PATH_2_BACKUP) then errormsg "  " & vbcrlf & PATH_2_BACKUP
	on error goto 0
end if

datetime = now
d = datepart("d",datetime)
if d<10 then d = "0" & ds
mm = datepart("m",datetime)
if mm<10 then mm = "0" & mm
y = datepart("yyyy",datetime)
h = datepart("h",datetime)
if h<10 then h = "0" & h
m = datepart("n",datetime)
if m<10 then m = "0" & m
s = datepart("s",datetime)
if s<10 then s = "0" & s
data_folder = y & "." & mm & "." & d & " " & h & "_" & m & "_" & s
folder = fso.buildpath(PATH_2_BACKUP,data_folder)
if fso.folderexists(folder) then
	answer = msgbox("  " & vbcrlf & folder & vbcrlf & "?",4,"")
	if (answer = 7) then errormsg(" ")
else
	fso.createfolder(folder)
end if
date_file = y & mm & d & h & m & s
file_bac = base_db & "_" & date_file & "." & backupExtensionName
fileExport = fso.buildpath(folder,file_bac)
if fso.fileexists(fileExport) then
	answer = msgbox(" ?" & vbcrlf & fileExport & vbcrlf & "?",4,"")
	if (answer = 7) then errormsg(" ")
end if

set wshshell = createobject("wscript.shell")
file_cmd = """" & mysqldump_file & """ -u" & base_db_name & " -p" & base_db_pass & " " & extradump_option & " """ & base_db & """ > """ & fileExport & """"
retcode = wshshell.run("cmd.exe /Q /c """ & file_cmd & """",cmdWindowVisible,true)
partquestion = ""
if retcode <> 0 then
	partquestion = "mysqldump.exe   "
elseif not fso.FileExists(fileExport) then
	partquestion = " .   "
else
	set fileExportObj = FSO.GetFile(fileExport)
	if fileExportObj.size = 0  then partquestion = " .   "
end if
if partquestion <> "" then
	answer = msgbox(partquestion & vbcrlf & fileExport & vbcrlf & " ?",4,"")
	if answer = 6 then FSO.DeleteFolder folder, 1
end if

function errormsg(text)
	msgbox text & vbcrlf & "Exit...", vbOKOnly, "Error"
	quit
end function

function quit()
	WScript.Quit
end function
